function initMainApp(sPath){
  Tristesse.init();
  Global.path_resources = sPath;
  // Carica il file delle risorse
  loadResources();
}

function loadResources(){
  $.ajax({
    type: "GET",
    url: Global.path_resources,
    dataType: "xml",
    success: resourcesLoadedOk,
    error: resourcesLoadedKo
  });  
}

function resourcesLoadedOk(xml){
  Global.resources = $.xml2json(xml);
  // Carica il file delle labels
  loadLabels();
}

function resourcesLoadedKo(){
  Tristesse.trace("Error loading "+Global.path_resources);
}


function loadLabels(){
  $.ajax({
    type: "GET",
    url: Global.resources.path_labels,
    dataType: "xml",
    success: labelsLoadedOk,
    error: labelsLoadedKo
  });  
}


function labelsLoadedOk(xml){
  // Inizializza le labels
  Lng.init(xml)
  initTagging();
}

function labelsLoadedKo(){
  Tristesse.trace("Error loading labels!");
}

function initTagging(){
  // inizializza il tagging
  Tag.init(Global.resources);
	loadElencoDemo();
}

function loadElencoDemo(){
	jQuery("#altro").hide();
  $.ajax({
    type: "GET",
    url: Global.resources.path_demo,
    dataType: "xml",
    success: demoLoadedOk,
    error: demoLoadedKo
  });  
}

function demoLoadedOk(xml){
  // 
	buildElencoDemo(xml);
  appInited();
}

function demoLoadedKo(){
  appInited();
}


function appInited(){
  
  // Tagga l'evento
  Tag.tag("hp");
  
  // Nasconde il preloader
  hidePreloaderapp();
  
  // Mosta l'app
  Global._app = $(".mainApp");
  Global._app.show();
  
  // Entry point
  appReady(); // in MainApp.js
}

function buildElencoDemo(xml){
	var toAppend = jQuery("#elencoDemo");
	jQuery("#altro").show();
  var o = $.xml2json(xml); 
	
	jQuery(".demoElement").hide();
	var ref = jQuery(".demoElement").clone();
	
	var a = Pqp.geta(o.demos.demo)
	
	for (var x=0;x<a.length;x++){
		var oTmp = a[x];
		
		if (oTmp.id != ID_DEMO){
			var mc = ref.clone();
			toAppend.append(mc)
			mc.show();
			jQuery("img",mc).attr("src",oTmp.img);
			jQuery("label",mc).html(""+oTmp.text);
		}
	}
	
	
}
